﻿// #DisappearedFootnotes.jsx

// https://forum.rudtp.ru/threads/propadajut-snoski.75265/#post-1184596
//  Странность -- сноски в тексте есть, но на экране их нет.
// Попытка инициировать пересчёт макета:
// в выделенном тексте для каждого текстового фрейма:
//  a) узнаётся его высота
//  б) высота увеличивается на 1 единицы измерения
//  в) восстанавливается прежняя высота

// Возможно, этого будет достаточно, чтобы возвращать все исчезнувшие сноски. 
//  Можно делать для профилактики, раз такой непредсказуемый косяк появился в индизайне.

// © Михаил Иванюшин, 2020  |  dotextok@gmail.com  |  dotextok.ru 

#targetengine "DisappearedFootnotes" 

// идея прогресс-бара взята тут: http://forums.adobe.com/message/3152162#3152162
var ProgressBar = function(title) { // ProgressBar
     var w = new Window('palette', title, {x:0, y:0, width:1000, height:40},{closeButton: true}), pb = w.add('progressbar', {x:20, y:12, width:960, height:12});       
          w.center();
     this.reset = function(maxValue) {
          pb.value = 0;
          pb.maxvalue = maxValue;
          pb.visible = maxValue;
          w.show();
          w.update();
      };
     this.hit = function() {++pb.value; w.update();};
     this.close = function() {w.close();};
} // ProgressBar
//////////////////////////////

var pBar;
var myParentPage;
var parseIntAppVersion = parseInt (app.version); 

var programTitul = "Поиск исчезнувших сносок";
if (app.documents.length == 0) { // length == 0
    alert("Нет открытых документов.", programTitul);
    exit();
    } // length == 0
var myDoc = app.activeDocument;
var mySel = app.selection[0];
try {
    var whatIsSelected = "Text, TextColumn, Story, Paragraph, Line, Word, Character, TextStyleRange".match(mySel.reflect.name);
    }
catch (e) { };
if ((mySel == undefined) || (whatIsSelected == null)) { // undefined
    alert ("Должен быть выбран текст.", programTitul);
    exit();
    } // undefined
var story = mySel.parentStory;
var tcLength = story.textContainers.length;
pBar = new ProgressBar(programTitul)
pBar.reset(tcLength);
for (i = tcLength-1; i >= 0; i--, pBar.hit()) { // i--
    var tc = story.textContainers[i];
    var gB = tc.geometricBounds;
    var yT = gB[0];
    var xT = gB[1];
    var yB = gB[2];
    var xB = gB[3];
    tc.geometricBounds = [yT,xT,yB+1,xB];
    tc.geometricBounds = [yT,xT,yB,xB]; 
    } // i--
pBar.close();
app.documents[0].select(NothingEnum.nothing);
story.recompose();


